#include "ldrom.h"

void FMC_Open(void)
{
  SYSCLK->AHBCLK |=  4 ;                         // Enable ISP CLK 
  FMC->ISPCON    |=  FMC_ISPCON_ISPEN_Msk ;      // Enable ISP function 	
  FMC->ISPCON    |=  FMC_ISPCON_LDUEN_Msk ;      // Enable LDROM Update  
}
void FMC_Erase(uint32_t u32addr)
{
  FMC->ISPCMD = FMC_ISPCMD_PAGE_ERASE ;
  FMC->ISPADR = u32addr ;
  FMC->ISPTRG = 0x1 ;
  while(FMC->ISPTRG) ;
}
void FMC_Write(uint32_t u32addr, uint32_t u32data)
{
  FMC->ISPCMD = FMC_ISPCMD_PROGRAM ;
  FMC->ISPADR = u32addr ;
  FMC->ISPDAT = u32data ;
  FMC->ISPTRG = 0x1 ;  
  while(FMC->ISPTRG) ;
}
uint32_t FMC_Read(uint32_t u32addr)
{ 
  FMC->ISPCMD = FMC_ISPCMD_READ ;
  FMC->ISPADR = u32addr ;
  FMC->ISPDAT = 0 ;
  FMC->ISPTRG = 0x1 ;
  while(FMC->ISPTRG) ;
  return FMC->ISPDAT ;
}
void FMC_Close(void)
{
  SYSCLK->AHBCLK |=  4 ;                         // Enable ISP CLK 
  FMC->ISPCON &= ~FMC_ISPCON_ISPEN_Msk ;         // Enable ISP function 	
  FMC->ISPCON &= ~FMC_ISPCON_LDUEN_Msk ;         // Enable LDROM Update  
}

void UnlockReg(void)
{   
  SYS->REGWRPROT = 0x59 ;
  SYS->REGWRPROT = 0x16 ;
  SYS->REGWRPROT = 0x88 ;
}
void LockReg(void)
{
  SYS->REGWRPROT = 0 ;
}
